// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/LrosSignalsActualValues.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__LROS_SIGNALS_ACTUAL_VALUES__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__DETAIL__LROS_SIGNALS_ACTUAL_VALUES__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__LrosSignalsActualValues __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__LrosSignalsActualValues __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LrosSignalsActualValues_
{
  using Type = LrosSignalsActualValues_<ContainerAllocator>;

  explicit LrosSignalsActualValues_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_power_supp_ford = 0;
      this->can_power_motive_ford = 0;
      this->can_cruise_status_ford = 0.0f;
      this->can_veh_batt_volt = 0;
      this->can_gear_position = 0;
      this->can_ambient_temp = 0.0f;
      this->can_ign_status = 0;
    }
  }

  explicit LrosSignalsActualValues_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_power_supp_ford = 0;
      this->can_power_motive_ford = 0;
      this->can_cruise_status_ford = 0.0f;
      this->can_veh_batt_volt = 0;
      this->can_gear_position = 0;
      this->can_ambient_temp = 0.0f;
      this->can_ign_status = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_power_supp_ford_type =
    uint8_t;
  _can_power_supp_ford_type can_power_supp_ford;
  using _can_power_motive_ford_type =
    uint8_t;
  _can_power_motive_ford_type can_power_motive_ford;
  using _can_cruise_status_ford_type =
    float;
  _can_cruise_status_ford_type can_cruise_status_ford;
  using _can_veh_batt_volt_type =
    uint8_t;
  _can_veh_batt_volt_type can_veh_batt_volt;
  using _can_gear_position_type =
    uint16_t;
  _can_gear_position_type can_gear_position;
  using _can_ambient_temp_type =
    float;
  _can_ambient_temp_type can_ambient_temp;
  using _can_ign_status_type =
    uint8_t;
  _can_ign_status_type can_ign_status;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_power_supp_ford(
    const uint8_t & _arg)
  {
    this->can_power_supp_ford = _arg;
    return *this;
  }
  Type & set__can_power_motive_ford(
    const uint8_t & _arg)
  {
    this->can_power_motive_ford = _arg;
    return *this;
  }
  Type & set__can_cruise_status_ford(
    const float & _arg)
  {
    this->can_cruise_status_ford = _arg;
    return *this;
  }
  Type & set__can_veh_batt_volt(
    const uint8_t & _arg)
  {
    this->can_veh_batt_volt = _arg;
    return *this;
  }
  Type & set__can_gear_position(
    const uint16_t & _arg)
  {
    this->can_gear_position = _arg;
    return *this;
  }
  Type & set__can_ambient_temp(
    const float & _arg)
  {
    this->can_ambient_temp = _arg;
    return *this;
  }
  Type & set__can_ign_status(
    const uint8_t & _arg)
  {
    this->can_ign_status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__LrosSignalsActualValues
    std::shared_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__LrosSignalsActualValues
    std::shared_ptr<delphi_mrr_msgs::msg::LrosSignalsActualValues_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LrosSignalsActualValues_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_power_supp_ford != other.can_power_supp_ford) {
      return false;
    }
    if (this->can_power_motive_ford != other.can_power_motive_ford) {
      return false;
    }
    if (this->can_cruise_status_ford != other.can_cruise_status_ford) {
      return false;
    }
    if (this->can_veh_batt_volt != other.can_veh_batt_volt) {
      return false;
    }
    if (this->can_gear_position != other.can_gear_position) {
      return false;
    }
    if (this->can_ambient_temp != other.can_ambient_temp) {
      return false;
    }
    if (this->can_ign_status != other.can_ign_status) {
      return false;
    }
    return true;
  }
  bool operator!=(const LrosSignalsActualValues_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LrosSignalsActualValues_

// alias to use template instance with default allocator
using LrosSignalsActualValues =
  delphi_mrr_msgs::msg::LrosSignalsActualValues_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__LROS_SIGNALS_ACTUAL_VALUES__STRUCT_HPP_
