// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/SystemStatus.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__SYSTEM_STATUS__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__DETAIL__SYSTEM_STATUS__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__SystemStatus __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__SystemStatus __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemStatus_
{
  using Type = SystemStatus_<ContainerAllocator>;

  explicit SystemStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_vehicle_stat = false;
      this->can_day_night_status = false;
      this->can_wiper_status = false;
      this->can_yaw_rate_validity = false;
      this->can_yaw_rate = 0.0f;
      this->can_vehicle_speed_validity = false;
      this->can_vehicle_speed_direction = false;
      this->can_vehicle_speed = 0.0f;
    }
  }

  explicit SystemStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_vehicle_stat = false;
      this->can_day_night_status = false;
      this->can_wiper_status = false;
      this->can_yaw_rate_validity = false;
      this->can_yaw_rate = 0.0f;
      this->can_vehicle_speed_validity = false;
      this->can_vehicle_speed_direction = false;
      this->can_vehicle_speed = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_vehicle_stat_type =
    bool;
  _can_vehicle_stat_type can_vehicle_stat;
  using _can_day_night_status_type =
    bool;
  _can_day_night_status_type can_day_night_status;
  using _can_wiper_status_type =
    bool;
  _can_wiper_status_type can_wiper_status;
  using _can_yaw_rate_validity_type =
    bool;
  _can_yaw_rate_validity_type can_yaw_rate_validity;
  using _can_yaw_rate_type =
    float;
  _can_yaw_rate_type can_yaw_rate;
  using _can_vehicle_speed_validity_type =
    bool;
  _can_vehicle_speed_validity_type can_vehicle_speed_validity;
  using _can_vehicle_speed_direction_type =
    bool;
  _can_vehicle_speed_direction_type can_vehicle_speed_direction;
  using _can_vehicle_speed_type =
    float;
  _can_vehicle_speed_type can_vehicle_speed;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_vehicle_stat(
    const bool & _arg)
  {
    this->can_vehicle_stat = _arg;
    return *this;
  }
  Type & set__can_day_night_status(
    const bool & _arg)
  {
    this->can_day_night_status = _arg;
    return *this;
  }
  Type & set__can_wiper_status(
    const bool & _arg)
  {
    this->can_wiper_status = _arg;
    return *this;
  }
  Type & set__can_yaw_rate_validity(
    const bool & _arg)
  {
    this->can_yaw_rate_validity = _arg;
    return *this;
  }
  Type & set__can_yaw_rate(
    const float & _arg)
  {
    this->can_yaw_rate = _arg;
    return *this;
  }
  Type & set__can_vehicle_speed_validity(
    const bool & _arg)
  {
    this->can_vehicle_speed_validity = _arg;
    return *this;
  }
  Type & set__can_vehicle_speed_direction(
    const bool & _arg)
  {
    this->can_vehicle_speed_direction = _arg;
    return *this;
  }
  Type & set__can_vehicle_speed(
    const float & _arg)
  {
    this->can_vehicle_speed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemStatus
    std::shared_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemStatus
    std::shared_ptr<delphi_mrr_msgs::msg::SystemStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_vehicle_stat != other.can_vehicle_stat) {
      return false;
    }
    if (this->can_day_night_status != other.can_day_night_status) {
      return false;
    }
    if (this->can_wiper_status != other.can_wiper_status) {
      return false;
    }
    if (this->can_yaw_rate_validity != other.can_yaw_rate_validity) {
      return false;
    }
    if (this->can_yaw_rate != other.can_yaw_rate) {
      return false;
    }
    if (this->can_vehicle_speed_validity != other.can_vehicle_speed_validity) {
      return false;
    }
    if (this->can_vehicle_speed_direction != other.can_vehicle_speed_direction) {
      return false;
    }
    if (this->can_vehicle_speed != other.can_vehicle_speed) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemStatus_

// alias to use template instance with default allocator
using SystemStatus =
  delphi_mrr_msgs::msg::SystemStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__SYSTEM_STATUS__STRUCT_HPP_
