// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/IFVStatusCompensated.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__IFV_STATUS_COMPENSATED__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__DETAIL__IFV_STATUS_COMPENSATED__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__IFVStatusCompensated __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__IFVStatusCompensated __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IFVStatusCompensated_
{
  using Type = IFVStatusCompensated_<ContainerAllocator>;

  explicit IFVStatusCompensated_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_yaw_rate_calc_qf = 0;
      this->can_yaw_rate_calc = 0.0f;
      this->can_yaw_rate_bias = 0.0f;
      this->can_vehicle_speed_calc = 0.0f;
      this->can_veh_spd_comp_factor = 0.0f;
    }
  }

  explicit IFVStatusCompensated_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_yaw_rate_calc_qf = 0;
      this->can_yaw_rate_calc = 0.0f;
      this->can_yaw_rate_bias = 0.0f;
      this->can_vehicle_speed_calc = 0.0f;
      this->can_veh_spd_comp_factor = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_yaw_rate_calc_qf_type =
    uint8_t;
  _can_yaw_rate_calc_qf_type can_yaw_rate_calc_qf;
  using _can_yaw_rate_calc_type =
    float;
  _can_yaw_rate_calc_type can_yaw_rate_calc;
  using _can_yaw_rate_bias_type =
    float;
  _can_yaw_rate_bias_type can_yaw_rate_bias;
  using _can_vehicle_speed_calc_type =
    float;
  _can_vehicle_speed_calc_type can_vehicle_speed_calc;
  using _can_veh_spd_comp_factor_type =
    float;
  _can_veh_spd_comp_factor_type can_veh_spd_comp_factor;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_yaw_rate_calc_qf(
    const uint8_t & _arg)
  {
    this->can_yaw_rate_calc_qf = _arg;
    return *this;
  }
  Type & set__can_yaw_rate_calc(
    const float & _arg)
  {
    this->can_yaw_rate_calc = _arg;
    return *this;
  }
  Type & set__can_yaw_rate_bias(
    const float & _arg)
  {
    this->can_yaw_rate_bias = _arg;
    return *this;
  }
  Type & set__can_vehicle_speed_calc(
    const float & _arg)
  {
    this->can_vehicle_speed_calc = _arg;
    return *this;
  }
  Type & set__can_veh_spd_comp_factor(
    const float & _arg)
  {
    this->can_veh_spd_comp_factor = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__IFVStatusCompensated
    std::shared_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__IFVStatusCompensated
    std::shared_ptr<delphi_mrr_msgs::msg::IFVStatusCompensated_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IFVStatusCompensated_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_yaw_rate_calc_qf != other.can_yaw_rate_calc_qf) {
      return false;
    }
    if (this->can_yaw_rate_calc != other.can_yaw_rate_calc) {
      return false;
    }
    if (this->can_yaw_rate_bias != other.can_yaw_rate_bias) {
      return false;
    }
    if (this->can_vehicle_speed_calc != other.can_vehicle_speed_calc) {
      return false;
    }
    if (this->can_veh_spd_comp_factor != other.can_veh_spd_comp_factor) {
      return false;
    }
    return true;
  }
  bool operator!=(const IFVStatusCompensated_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IFVStatusCompensated_

// alias to use template instance with default allocator
using IFVStatusCompensated =
  delphi_mrr_msgs::msg::IFVStatusCompensated_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__IFV_STATUS_COMPENSATED__STRUCT_HPP_
