// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/LrosCarCfgFord.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__LROS_CAR_CFG_FORD__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__DETAIL__LROS_CAR_CFG_FORD__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__LrosCarCfgFord __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__LrosCarCfgFord __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LrosCarCfgFord_
{
  using Type = LrosCarCfgFord_<ContainerAllocator>;

  explicit LrosCarCfgFord_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->k_radar_azimuth_polarity = 0;
      this->can_fa_vert_ground_offset = 0.0f;
      this->can_fa_vert_lower_limit = 0.0f;
      this->can_fa_vert_upper_limit = 0.0f;
      this->can_lros_carcfgvehtype_ford = 0;
      this->can_lros_carcfgengine_ford = 0;
    }
  }

  explicit LrosCarCfgFord_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->k_radar_azimuth_polarity = 0;
      this->can_fa_vert_ground_offset = 0.0f;
      this->can_fa_vert_lower_limit = 0.0f;
      this->can_fa_vert_upper_limit = 0.0f;
      this->can_lros_carcfgvehtype_ford = 0;
      this->can_lros_carcfgengine_ford = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _k_radar_azimuth_polarity_type =
    int8_t;
  _k_radar_azimuth_polarity_type k_radar_azimuth_polarity;
  using _can_fa_vert_ground_offset_type =
    float;
  _can_fa_vert_ground_offset_type can_fa_vert_ground_offset;
  using _can_fa_vert_lower_limit_type =
    float;
  _can_fa_vert_lower_limit_type can_fa_vert_lower_limit;
  using _can_fa_vert_upper_limit_type =
    float;
  _can_fa_vert_upper_limit_type can_fa_vert_upper_limit;
  using _can_lros_carcfgvehtype_ford_type =
    uint8_t;
  _can_lros_carcfgvehtype_ford_type can_lros_carcfgvehtype_ford;
  using _can_lros_carcfgengine_ford_type =
    uint8_t;
  _can_lros_carcfgengine_ford_type can_lros_carcfgengine_ford;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__k_radar_azimuth_polarity(
    const int8_t & _arg)
  {
    this->k_radar_azimuth_polarity = _arg;
    return *this;
  }
  Type & set__can_fa_vert_ground_offset(
    const float & _arg)
  {
    this->can_fa_vert_ground_offset = _arg;
    return *this;
  }
  Type & set__can_fa_vert_lower_limit(
    const float & _arg)
  {
    this->can_fa_vert_lower_limit = _arg;
    return *this;
  }
  Type & set__can_fa_vert_upper_limit(
    const float & _arg)
  {
    this->can_fa_vert_upper_limit = _arg;
    return *this;
  }
  Type & set__can_lros_carcfgvehtype_ford(
    const uint8_t & _arg)
  {
    this->can_lros_carcfgvehtype_ford = _arg;
    return *this;
  }
  Type & set__can_lros_carcfgengine_ford(
    const uint8_t & _arg)
  {
    this->can_lros_carcfgengine_ford = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__LrosCarCfgFord
    std::shared_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__LrosCarCfgFord
    std::shared_ptr<delphi_mrr_msgs::msg::LrosCarCfgFord_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LrosCarCfgFord_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->k_radar_azimuth_polarity != other.k_radar_azimuth_polarity) {
      return false;
    }
    if (this->can_fa_vert_ground_offset != other.can_fa_vert_ground_offset) {
      return false;
    }
    if (this->can_fa_vert_lower_limit != other.can_fa_vert_lower_limit) {
      return false;
    }
    if (this->can_fa_vert_upper_limit != other.can_fa_vert_upper_limit) {
      return false;
    }
    if (this->can_lros_carcfgvehtype_ford != other.can_lros_carcfgvehtype_ford) {
      return false;
    }
    if (this->can_lros_carcfgengine_ford != other.can_lros_carcfgengine_ford) {
      return false;
    }
    return true;
  }
  bool operator!=(const LrosCarCfgFord_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LrosCarCfgFord_

// alias to use template instance with default allocator
using LrosCarCfgFord =
  delphi_mrr_msgs::msg::LrosCarCfgFord_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__LROS_CAR_CFG_FORD__STRUCT_HPP_
