// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/SystemAlignment2.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__SYSTEM_ALIGNMENT2__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__DETAIL__SYSTEM_ALIGNMENT2__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment2 __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment2 __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemAlignment2_
{
  using Type = SystemAlignment2_<ContainerAllocator>;

  explicit SystemAlignment2_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_serv_align_updates_need = 0;
      this->can_serv_align_type = false;
      this->can_radar_height = 0;
      this->can_radar_fov_mr = 0;
      this->can_radar_fov_rr = 0;
      this->can_align_enable = 0;
      this->can_angle_mounting_hoffset = 0.0f;
      this->can_aalign_avg_ctr_total = 0;
    }
  }

  explicit SystemAlignment2_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_serv_align_updates_need = 0;
      this->can_serv_align_type = false;
      this->can_radar_height = 0;
      this->can_radar_fov_mr = 0;
      this->can_radar_fov_rr = 0;
      this->can_align_enable = 0;
      this->can_angle_mounting_hoffset = 0.0f;
      this->can_aalign_avg_ctr_total = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_serv_align_updates_need_type =
    uint8_t;
  _can_serv_align_updates_need_type can_serv_align_updates_need;
  using _can_serv_align_type_type =
    bool;
  _can_serv_align_type_type can_serv_align_type;
  using _can_radar_height_type =
    uint8_t;
  _can_radar_height_type can_radar_height;
  using _can_radar_fov_mr_type =
    uint8_t;
  _can_radar_fov_mr_type can_radar_fov_mr;
  using _can_radar_fov_rr_type =
    uint8_t;
  _can_radar_fov_rr_type can_radar_fov_rr;
  using _can_align_enable_type =
    uint8_t;
  _can_align_enable_type can_align_enable;
  using _can_angle_mounting_hoffset_type =
    float;
  _can_angle_mounting_hoffset_type can_angle_mounting_hoffset;
  using _can_aalign_avg_ctr_total_type =
    uint8_t;
  _can_aalign_avg_ctr_total_type can_aalign_avg_ctr_total;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_serv_align_updates_need(
    const uint8_t & _arg)
  {
    this->can_serv_align_updates_need = _arg;
    return *this;
  }
  Type & set__can_serv_align_type(
    const bool & _arg)
  {
    this->can_serv_align_type = _arg;
    return *this;
  }
  Type & set__can_radar_height(
    const uint8_t & _arg)
  {
    this->can_radar_height = _arg;
    return *this;
  }
  Type & set__can_radar_fov_mr(
    const uint8_t & _arg)
  {
    this->can_radar_fov_mr = _arg;
    return *this;
  }
  Type & set__can_radar_fov_rr(
    const uint8_t & _arg)
  {
    this->can_radar_fov_rr = _arg;
    return *this;
  }
  Type & set__can_align_enable(
    const uint8_t & _arg)
  {
    this->can_align_enable = _arg;
    return *this;
  }
  Type & set__can_angle_mounting_hoffset(
    const float & _arg)
  {
    this->can_angle_mounting_hoffset = _arg;
    return *this;
  }
  Type & set__can_aalign_avg_ctr_total(
    const uint8_t & _arg)
  {
    this->can_aalign_avg_ctr_total = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment2
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__SystemAlignment2
    std::shared_ptr<delphi_mrr_msgs::msg::SystemAlignment2_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemAlignment2_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_serv_align_updates_need != other.can_serv_align_updates_need) {
      return false;
    }
    if (this->can_serv_align_type != other.can_serv_align_type) {
      return false;
    }
    if (this->can_radar_height != other.can_radar_height) {
      return false;
    }
    if (this->can_radar_fov_mr != other.can_radar_fov_mr) {
      return false;
    }
    if (this->can_radar_fov_rr != other.can_radar_fov_rr) {
      return false;
    }
    if (this->can_align_enable != other.can_align_enable) {
      return false;
    }
    if (this->can_angle_mounting_hoffset != other.can_angle_mounting_hoffset) {
      return false;
    }
    if (this->can_aalign_avg_ctr_total != other.can_aalign_avg_ctr_total) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemAlignment2_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemAlignment2_

// alias to use template instance with default allocator
using SystemAlignment2 =
  delphi_mrr_msgs::msg::SystemAlignment2_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__SYSTEM_ALIGNMENT2__STRUCT_HPP_
