// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from delphi_mrr_msgs:msg/WheelSpeedMsg.idl
// generated code does not contain a copyright notice
#include "delphi_mrr_msgs/msg/detail/wheel_speed_msg__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
delphi_mrr_msgs__msg__WheelSpeedMsg__init(delphi_mrr_msgs__msg__WheelSpeedMsg * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    delphi_mrr_msgs__msg__WheelSpeedMsg__fini(msg);
    return false;
  }
  // can_speed_front_left_wheel
  // can_speed_front_right_wheel
  // can_speed_rear_left_wheel
  // can_speed_rear_right_wheel
  return true;
}

void
delphi_mrr_msgs__msg__WheelSpeedMsg__fini(delphi_mrr_msgs__msg__WheelSpeedMsg * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // can_speed_front_left_wheel
  // can_speed_front_right_wheel
  // can_speed_rear_left_wheel
  // can_speed_rear_right_wheel
}

bool
delphi_mrr_msgs__msg__WheelSpeedMsg__are_equal(const delphi_mrr_msgs__msg__WheelSpeedMsg * lhs, const delphi_mrr_msgs__msg__WheelSpeedMsg * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // can_speed_front_left_wheel
  if (lhs->can_speed_front_left_wheel != rhs->can_speed_front_left_wheel) {
    return false;
  }
  // can_speed_front_right_wheel
  if (lhs->can_speed_front_right_wheel != rhs->can_speed_front_right_wheel) {
    return false;
  }
  // can_speed_rear_left_wheel
  if (lhs->can_speed_rear_left_wheel != rhs->can_speed_rear_left_wheel) {
    return false;
  }
  // can_speed_rear_right_wheel
  if (lhs->can_speed_rear_right_wheel != rhs->can_speed_rear_right_wheel) {
    return false;
  }
  return true;
}

bool
delphi_mrr_msgs__msg__WheelSpeedMsg__copy(
  const delphi_mrr_msgs__msg__WheelSpeedMsg * input,
  delphi_mrr_msgs__msg__WheelSpeedMsg * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // can_speed_front_left_wheel
  output->can_speed_front_left_wheel = input->can_speed_front_left_wheel;
  // can_speed_front_right_wheel
  output->can_speed_front_right_wheel = input->can_speed_front_right_wheel;
  // can_speed_rear_left_wheel
  output->can_speed_rear_left_wheel = input->can_speed_rear_left_wheel;
  // can_speed_rear_right_wheel
  output->can_speed_rear_right_wheel = input->can_speed_rear_right_wheel;
  return true;
}

delphi_mrr_msgs__msg__WheelSpeedMsg *
delphi_mrr_msgs__msg__WheelSpeedMsg__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_mrr_msgs__msg__WheelSpeedMsg * msg = (delphi_mrr_msgs__msg__WheelSpeedMsg *)allocator.allocate(sizeof(delphi_mrr_msgs__msg__WheelSpeedMsg), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(delphi_mrr_msgs__msg__WheelSpeedMsg));
  bool success = delphi_mrr_msgs__msg__WheelSpeedMsg__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
delphi_mrr_msgs__msg__WheelSpeedMsg__destroy(delphi_mrr_msgs__msg__WheelSpeedMsg * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    delphi_mrr_msgs__msg__WheelSpeedMsg__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__init(delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_mrr_msgs__msg__WheelSpeedMsg * data = NULL;

  if (size) {
    data = (delphi_mrr_msgs__msg__WheelSpeedMsg *)allocator.zero_allocate(size, sizeof(delphi_mrr_msgs__msg__WheelSpeedMsg), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = delphi_mrr_msgs__msg__WheelSpeedMsg__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        delphi_mrr_msgs__msg__WheelSpeedMsg__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__fini(delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      delphi_mrr_msgs__msg__WheelSpeedMsg__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence *
delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * array = (delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence *)allocator.allocate(sizeof(delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__destroy(delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__are_equal(const delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * lhs, const delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!delphi_mrr_msgs__msg__WheelSpeedMsg__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence__copy(
  const delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * input,
  delphi_mrr_msgs__msg__WheelSpeedMsg__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(delphi_mrr_msgs__msg__WheelSpeedMsg);
    delphi_mrr_msgs__msg__WheelSpeedMsg * data =
      (delphi_mrr_msgs__msg__WheelSpeedMsg *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!delphi_mrr_msgs__msg__WheelSpeedMsg__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          delphi_mrr_msgs__msg__WheelSpeedMsg__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!delphi_mrr_msgs__msg__WheelSpeedMsg__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
