// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_mrr_msgs:msg/WheelSpeedMsg.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_MRR_MSGS__MSG__DETAIL__WHEEL_SPEED_MSG__STRUCT_HPP_
#define DELPHI_MRR_MSGS__MSG__DETAIL__WHEEL_SPEED_MSG__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_mrr_msgs__msg__WheelSpeedMsg __attribute__((deprecated))
#else
# define DEPRECATED__delphi_mrr_msgs__msg__WheelSpeedMsg __declspec(deprecated)
#endif

namespace delphi_mrr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WheelSpeedMsg_
{
  using Type = WheelSpeedMsg_<ContainerAllocator>;

  explicit WheelSpeedMsg_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_speed_front_left_wheel = 0;
      this->can_speed_front_right_wheel = 0;
      this->can_speed_rear_left_wheel = 0;
      this->can_speed_rear_right_wheel = 0;
    }
  }

  explicit WheelSpeedMsg_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->can_speed_front_left_wheel = 0;
      this->can_speed_front_right_wheel = 0;
      this->can_speed_rear_left_wheel = 0;
      this->can_speed_rear_right_wheel = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _can_speed_front_left_wheel_type =
    uint16_t;
  _can_speed_front_left_wheel_type can_speed_front_left_wheel;
  using _can_speed_front_right_wheel_type =
    uint16_t;
  _can_speed_front_right_wheel_type can_speed_front_right_wheel;
  using _can_speed_rear_left_wheel_type =
    uint16_t;
  _can_speed_rear_left_wheel_type can_speed_rear_left_wheel;
  using _can_speed_rear_right_wheel_type =
    uint16_t;
  _can_speed_rear_right_wheel_type can_speed_rear_right_wheel;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__can_speed_front_left_wheel(
    const uint16_t & _arg)
  {
    this->can_speed_front_left_wheel = _arg;
    return *this;
  }
  Type & set__can_speed_front_right_wheel(
    const uint16_t & _arg)
  {
    this->can_speed_front_right_wheel = _arg;
    return *this;
  }
  Type & set__can_speed_rear_left_wheel(
    const uint16_t & _arg)
  {
    this->can_speed_rear_left_wheel = _arg;
    return *this;
  }
  Type & set__can_speed_rear_right_wheel(
    const uint16_t & _arg)
  {
    this->can_speed_rear_right_wheel = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_mrr_msgs__msg__WheelSpeedMsg
    std::shared_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_mrr_msgs__msg__WheelSpeedMsg
    std::shared_ptr<delphi_mrr_msgs::msg::WheelSpeedMsg_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WheelSpeedMsg_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->can_speed_front_left_wheel != other.can_speed_front_left_wheel) {
      return false;
    }
    if (this->can_speed_front_right_wheel != other.can_speed_front_right_wheel) {
      return false;
    }
    if (this->can_speed_rear_left_wheel != other.can_speed_rear_left_wheel) {
      return false;
    }
    if (this->can_speed_rear_right_wheel != other.can_speed_rear_right_wheel) {
      return false;
    }
    return true;
  }
  bool operator!=(const WheelSpeedMsg_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WheelSpeedMsg_

// alias to use template instance with default allocator
using WheelSpeedMsg =
  delphi_mrr_msgs::msg::WheelSpeedMsg_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_mrr_msgs

#endif  // DELPHI_MRR_MSGS__MSG__DETAIL__WHEEL_SPEED_MSG__STRUCT_HPP_
